#include <iostream>
#include <stdio.h>

using namespace std;
int niz[5000000];
int nz[500000];
int n,k;
void ispis(int i)
{
    for(int j=0;j<n;j++)
    {
        if(nz[j]) printf("%d ",niz[j]);
        else if(j>=i) printf("%d ",niz[j]);
    }
}
int mini(int ind,int k)
{int m=niz[ind],minii=ind;
if(k==0) ispis(ind);
   else { for(int j=ind;j<ind+k+1;j++)
    {
        if(niz[j]<m) {m=niz[j]; minii=j;}
    }
    nz[minii]=1;
    mini(minii+1,k-minii+ind);}

}
int main()
{ scanf("%d%d",&n,&k);
for(int i=0;i<n;i++)
{
    scanf("%d",&niz[i]);
}
mini(0,k);


    return 0;
}